﻿using HarmonyLib;
using System.Collections;
using UnityEngine;
using UnityEngine.Networking;
using UnityEngine.UI;

public class KUtility : Mod
{
    private bool ShowMenu;
    private GameObject menu;
    private AssetBundle asset;

    Image status_godmode;
    Image status_stableraft;
    Image status_devcheats;
    Image status_flymode;
    Image status_nooxygen;
    Image status_nofood;
    Image status_nothirst;
    Image status_nosharks;
    Image status_noseagulls;
    Image status_forceanchor;

    bool godmode;
    bool flymode;
    bool nooxygen;
    bool nofood;
    bool nothirst;
    bool nosharks;
    bool noseagulls;
    bool forceanchor;

    Color enabled_color = new Color(49 / 255.0f, 150 / 255.0f, 40 / 255.0f);
    Color disabled_color = new Color(153 / 255.0f, 45 / 255.0f, 45 / 255.0f);

    public IEnumerator Start()
    {
        if (GameObject.Find("KUtilityMenuCanvas"))
        {
            Destroy(GameObject.Find("KUtilityMenuCanvas"));
        }

        var request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("kutility.assets"));
        yield return request;
        asset = request.assetBundle;

        menu = Instantiate<GameObject>(asset.LoadAsset<GameObject>("KUtilityMenu"), Vector3.zero, Quaternion.identity);
        menu.GetComponent<CanvasGroup>().alpha = 0;
        menu.GetComponent<CanvasGroup>().interactable = false;
        menu.GetComponent<CanvasGroup>().blocksRaycasts = false;

        status_godmode = menu.transform.Find("Background").Find("Buttons").Find("GodMode").Find("Status").GetComponent<Image>();
        status_stableraft = menu.transform.Find("Background").Find("Buttons").Find("StableRaft").Find("Status").GetComponent<Image>();
        status_devcheats = menu.transform.Find("Background").Find("Buttons").Find("DevCheats").Find("Status").GetComponent<Image>();
        status_flymode = menu.transform.Find("Background").Find("Buttons").Find("FlyMode").Find("Status").GetComponent<Image>();
        status_nooxygen = menu.transform.Find("Background").Find("Buttons").Find("NoOxygen").Find("Status").GetComponent<Image>();
        status_nofood = menu.transform.Find("Background").Find("Buttons").Find("NoFood").Find("Status").GetComponent<Image>();
        status_nothirst = menu.transform.Find("Background").Find("Buttons").Find("NoThirst").Find("Status").GetComponent<Image>();
        status_nosharks = menu.transform.Find("Background").Find("Buttons").Find("NoSharks").Find("Status").GetComponent<Image>();
        status_noseagulls = menu.transform.Find("Background").Find("Buttons").Find("NoSeagulls").Find("Status").GetComponent<Image>();
        status_forceanchor = menu.transform.Find("Background").Find("Buttons").Find("ForceAnchor").Find("Status").GetComponent<Image>();

        status_godmode.GetComponentInParent<Button>().onClick.AddListener(ToggleGodMode);
        status_stableraft.GetComponentInParent<Button>().onClick.AddListener(ToggleStableRaft);
        status_devcheats.GetComponentInParent<Button>().onClick.AddListener(ToggleDevCheats);
        status_flymode.GetComponentInParent<Button>().onClick.AddListener(ToggleFlyMode);
        menu.transform.Find("Background").Find("Buttons").Find("ChangeWeather").GetComponent<Button>().onClick.AddListener(ChangeWeather);
        status_nooxygen.GetComponentInParent<Button>().onClick.AddListener(ToggleNoOxygen);
        status_nofood.GetComponentInParent<Button>().onClick.AddListener(ToggleNoFood);
        status_nothirst.GetComponentInParent<Button>().onClick.AddListener(ToggleNoThirst);
        status_nosharks.GetComponentInParent<Button>().onClick.AddListener(ToggleNoSharks);
        status_noseagulls.GetComponentInParent<Button>().onClick.AddListener(ToggleNoSeagulls);
        status_forceanchor.GetComponentInParent<Button>().onClick.AddListener(ToggleForceAnchor);

        menu.transform.Find("Background").Find("Topbar").GetComponentInChildren<Button>().onClick.AddListener(CloseBtn);

        DontDestroyOnLoad(menu);
        menu.name = "KUtilityMenuCanvas";
    }

    public IEnumerator GodMode()
    {
        while (godmode)
        {
            RAPI.GetLocalPlayer().Stats.stat_health.Value = 100;
            yield return new WaitForEndOfFrame();
        }
        yield break;
    }

    void ToggleGodMode()
    {
        godmode = !godmode;
        if (godmode)
            StartCoroutine(GodMode());
    }

    void ToggleStableRaft()
    {
        Buoyancy b = FindObjectOfType<Buoyancy>();
        b.active = !b.active;
        Transform t = (Transform)Traverse.Create(FindObjectOfType<Buoyancy>()).Field("rotatePivot").GetValue();
        t.rotation = Quaternion.Euler(0, 0, 0);
        Traverse.Create(FindObjectOfType<Buoyancy>()).Field("rotatePivot").SetValue(t);
    }

    void ToggleDevCheats()
    {
        //GameManager.UseCheats = !GameManager.UseCheats;
    }

    void ToggleFlyMode()
    {
        flymode = !flymode;
        if (flymode)
        {
            RAPI.GetLocalPlayer().flightCamera.Enable(true);
        }
        else
        {
            RAPI.GetLocalPlayer().flightCamera.Disable(true);
        }
    }

    void ChangeWeather()
    {
        Traverse.Create(ComponentManager<WeatherManager>.Value).Field("nextWeatherTimer").SetValue(0f);
    }

    public IEnumerator NoOxygen()
    {
        while (nooxygen)
        {
            RAPI.GetLocalPlayer().Stats.stat_oxygen.Value = 100;
            yield return new WaitForEndOfFrame();
        }
        yield break;
    }

    void ToggleNoOxygen()
    {
        nooxygen = !nooxygen;
        if (nooxygen)
            StartCoroutine(NoOxygen());
    }

    public IEnumerator NoFood()
    {
        while (nofood)
        {
            RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value = 100;
            RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value = 100;
            yield return new WaitForEndOfFrame();
        }
        yield break;
    }

    void ToggleNoFood()
    {
        nofood = !nofood;
        if (nofood)
            StartCoroutine(NoFood());
    }

    public IEnumerator NoThirst()
    {
        while (nothirst)
        {
            RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value = 100;
            RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value = 100;
            yield return new WaitForEndOfFrame();
        }
        yield break;
    }

    void ToggleNoThirst()
    {
        nothirst = !nothirst;
        if (nothirst)
            StartCoroutine(NoThirst());
    }

    public IEnumerator NoSharks()
    {
        while (nosharks)
        {
            if (ComponentManager<Network_Host_Entities>.Value.SharkCount > 0)
            {
                foreach (AI_StateMachine_Shark s in FindObjectsOfType<AI_StateMachine_Shark>())
                {
                    Destroy(s.gameObject);
                }
            }
            yield return new WaitForEndOfFrame();
        }
        yield break;
    }

    void ToggleNoSharks()
    {
        nosharks = !nosharks;
        if (nosharks)
            StartCoroutine(NoSharks());
    }

    public IEnumerator NoSeagulls()
{
    while (noseagulls)
    {
        if (ComponentManager<Network_Host_Entities>.Value.SeagullCount > 0)
        {
            foreach (Seagull s in FindObjectsOfType<Seagull>())
            {
                Destroy(s.gameObject);
            }
        }
        yield return new WaitForEndOfFrame();
    }
    yield break;
}

    void ToggleNoSeagulls()
    {
        noseagulls = !noseagulls;
        if (noseagulls)
            StartCoroutine(NoSeagulls());
    }

    void ToggleForceAnchor()
    {
        forceanchor = !forceanchor;
        if (forceanchor)
        {
            ComponentManager<Raft>.Value.AddAnchor(false, null);
        }
        else
        {
            ComponentManager<Raft>.Value.RemoveAnchor(10);
        }
    }

    public void CloseBtn()
    {
        ShowMenu = false;
        RAPI.ToggleCursor(ShowMenu);
        menu.GetComponent<CanvasGroup>().alpha = 0;
        menu.GetComponent<CanvasGroup>().interactable = false;
        menu.GetComponent<CanvasGroup>().blocksRaycasts = false;
    }

    public void LateUpdate()
    {
        if (ShowMenu)
        {
            status_godmode.color = godmode ? enabled_color : disabled_color;
            status_stableraft.color = !FindObjectOfType<Buoyancy>().active ? enabled_color : disabled_color;
            status_devcheats.color = disabled_color;
            status_flymode.color = RAPI.GetLocalPlayer().flightCamera.isActiveAndEnabled ? enabled_color : disabled_color;
            status_nooxygen.color = nooxygen ? enabled_color : disabled_color;
            status_nofood.color = nofood ? enabled_color : disabled_color;
            status_nothirst.color = nothirst ? enabled_color : disabled_color;
            status_nosharks.color = nosharks ? enabled_color : disabled_color;
            status_noseagulls.color = noseagulls ? enabled_color : disabled_color;
            status_forceanchor.color = forceanchor ? enabled_color : disabled_color;
        }
    }

    void ResetButtons()
    {
        // RESET ALL BTN TO DEFAULT STATE
    }

    public void Update()
    {
        if (asset == null) { return; }
        bool inLobbyScene = RAPI.IsCurrentSceneMainMenu();
        if (inLobbyScene)
        {
            ShowMenu = false;
            menu.GetComponent<CanvasGroup>().alpha = 0;
            menu.GetComponent<CanvasGroup>().interactable = false;
            menu.GetComponent<CanvasGroup>().blocksRaycasts = false;
            ResetButtons();
            return;
        }
        if ((Input.GetKey(KeyCode.K) && Input.GetKeyDown(KeyCode.U)) || (Input.GetKey(KeyCode.U) && Input.GetKeyDown(KeyCode.K)))
        {
            ShowMenu = !ShowMenu;
            RAPI.ToggleCursor(ShowMenu);
            if (ShowMenu)
            {
                menu.GetComponent<CanvasGroup>().alpha = 1;
                menu.GetComponent<CanvasGroup>().interactable = true;
                menu.GetComponent<CanvasGroup>().blocksRaycasts = true;
            }
            else
            {
                menu.GetComponent<CanvasGroup>().alpha = 0;
                menu.GetComponent<CanvasGroup>().interactable = false;
                menu.GetComponent<CanvasGroup>().blocksRaycasts = false;
            }
            return;
        }
    }

    public void OnModUnload()
    {
        asset.Unload(true);
        if (GameObject.Find("KUtilityMenuCanvas"))
        {
            Destroy(GameObject.Find("KUtilityMenuCanvas"));
        }
        Debug.Log("KUtility has been unloaded!");
    }
}